"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractGuard = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
class AbstractGuard extends (0, passport_1.AuthGuard)('jwt') {
    getAuthToken(context, authType) {
        const request = context.switchToHttp().getRequest();
        if (!Object.keys(request.headers).includes('authorization'))
            throw new common_1.UnauthorizedException('No Authentication Provided');
        if (request.headers.authorization.split(' ')[0] !== `${authType}`)
            throw new common_1.UnauthorizedException(`Wrong Authentication Type. ${authType} Authentication is required`);
        return request.headers.authorization;
    }
}
exports.AbstractGuard = AbstractGuard;
