"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpClientService = void 0;
const microservices_exceptions_1 = require("@devseeder/microservices-exceptions");
const nestjs_microservices_commons_1 = require("@devseeder/nestjs-microservices-commons");
const axios_1 = require("@nestjs/axios");
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
let HttpClientService = class HttpClientService extends nestjs_microservices_commons_1.AbstractService {
    constructor(url, httpService) {
        super();
        this.url = url;
        this.httpService = httpService;
    }
    getHeaders() {
        return {
            'Content-Type': 'application/json',
        };
    }
    post(endpoint, data) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this.logger.log(`Calling URL... ${this.url}${endpoint}`);
                this.logger.log(JSON.stringify(data));
                const response = yield (0, rxjs_1.firstValueFrom)(yield this.httpService.post(`${this.url}${endpoint}`, JSON.stringify(data), {
                    headers: this.getHeaders(),
                }));
                this.validateResponseStatus(response.data, response.status);
                return response;
            }
            catch (err) {
                this.logger.error(err.response.data);
                throw new microservices_exceptions_1.CustomErrorException(err.response.data.message, err.response.data.status, err.response.data.errorCode);
            }
        });
    }
    validateResponseStatus(data, status) {
        switch (status) {
            case common_1.HttpStatus.ACCEPTED:
            case common_1.HttpStatus.CREATED:
            case common_1.HttpStatus.OK:
            case common_1.HttpStatus.NO_CONTENT:
            case common_1.HttpStatus.OK:
                return true;
            default:
                throw new common_1.HttpException(data, status);
        }
    }
};
exports.HttpClientService = HttpClientService;
exports.HttpClientService = HttpClientService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [String, axios_1.HttpService])
], HttpClientService);
