/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/models" />
/// <reference types="mongoose/types/aggregate" />
/// <reference types="mongoose/types/callback" />
/// <reference types="mongoose/types/collection" />
/// <reference types="mongoose/types/connection" />
/// <reference types="mongoose/types/cursor" />
/// <reference types="mongoose/types/document" />
/// <reference types="mongoose/types/error" />
/// <reference types="mongoose/types/expressions" />
/// <reference types="mongoose/types/helpers" />
/// <reference types="mongoose/types/middlewares" />
/// <reference types="mongoose/types/indexes" />
/// <reference types="mongoose/types/mongooseoptions" />
/// <reference types="mongoose/types/pipelinestage" />
/// <reference types="mongoose/types/populate" />
/// <reference types="mongoose/types/query" />
/// <reference types="mongoose/types/schemaoptions" />
/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/types" />
/// <reference types="mongoose/types/utility" />
/// <reference types="mongoose/types/validation" />
/// <reference types="mongoose/types/virtuals" />
/// <reference types="mongoose/types/inferschematype" />
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { ObjectId } from 'mongoose';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { GenericCreateService, GenericRepository } from '@devseeder/nestjs-microservices-commons';
import { ClientAuthService } from '../client/client-auth.service';
import { UserBodyDto } from '../../dto/user.dto';
export declare class GenericCreateUserService<UserEntity, UserEntityBody extends UserBodyDto> extends GenericCreateService<UserEntity, UserEntity, UserEntityBody> {
    protected readonly repository: GenericRepository<UserEntity>;
    protected readonly fieldSchemaData: FieldSchema[];
    protected readonly entitySchemaData: EntitySchema[];
    protected readonly translationService: GetTranslationService;
    protected readonly errorService: ErrorService;
    protected readonly request?: Request;
    protected readonly scopeKey?: string;
    protected readonly clientAuthService?: ClientAuthService;
    protected readonly projectKey?: string;
    constructor(repository: GenericRepository<UserEntity>, fieldSchemaData: FieldSchema[], entitySchemaData: EntitySchema[], translationService: GetTranslationService, errorService: ErrorService, request?: Request, scopeKey?: string, clientAuthService?: ClientAuthService, projectKey?: string);
    create(body: UserEntityBody): Promise<{
        _id: ObjectId;
    }>;
    createUserAuth(user: UserEntityBody): Promise<string>;
}
