"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericCreateUserService = void 0;
const common_1 = require("@nestjs/common");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const core_1 = require("@nestjs/core");
const nestjs_microservices_commons_1 = require("@devseeder/nestjs-microservices-commons");
const client_auth_service_1 = require("../client/client-auth.service");
const user_auth_model_1 = require("../../auth/model/user-auth.model");
const app_constants_1 = require("../../app.constants");
let GenericCreateUserService = class GenericCreateUserService extends nestjs_microservices_commons_1.GenericCreateService {
    constructor(repository, fieldSchemaData, entitySchemaData, translationService, errorService, request, scopeKey, clientAuthService, projectKey) {
        super(repository, 'users', fieldSchemaData, entitySchemaData, translationService, errorService, request);
        this.repository = repository;
        this.fieldSchemaData = fieldSchemaData;
        this.entitySchemaData = entitySchemaData;
        this.translationService = translationService;
        this.errorService = errorService;
        this.request = request;
        this.scopeKey = scopeKey;
        this.clientAuthService = clientAuthService;
        this.projectKey = projectKey;
    }
    create(body) {
        const _super = Object.create(null, {
            create: { get: () => super.create }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const userAuthId = yield this.createUserAuth(body);
            return _super.create.call(this, Object.assign(Object.assign({}, body), { idUserAuth: userAuthId }));
        });
    }
    createUserAuth(user) {
        return __awaiter(this, void 0, void 0, function* () {
            const userAuth = new user_auth_model_1.UserAuth();
            userAuth.name = user.name;
            userAuth.username = user.username;
            userAuth.password = user.password;
            userAuth.projectKey = this.projectKey;
            userAuth.scopes = [
                `${this.scopeKey}/USER`,
                `${this.scopeKey}/UPDATE_PASSWORD`,
            ];
            const response = yield this.clientAuthService.createUser(userAuth);
            return response.response.userId;
        });
    }
};
exports.GenericCreateUserService = GenericCreateUserService;
exports.GenericCreateUserService = GenericCreateUserService = __decorate([
    (0, common_1.Injectable)({ scope: common_1.Scope.REQUEST }),
    __param(5, (0, common_1.Inject)(core_1.REQUEST)),
    __param(6, (0, common_1.Inject)(app_constants_1.AuthDITokens.SCOPE_KEY)),
    __param(8, (0, common_1.Inject)(app_constants_1.AuthDITokens.PROJECT_KEY)),
    __metadata("design:paramtypes", [nestjs_microservices_commons_1.GenericRepository, Array, Array, nestjs_microservices_schemas_1.GetTranslationService,
        nestjs_microservices_schemas_1.ErrorService,
        Request, String, client_auth_service_1.ClientAuthService, String])
], GenericCreateUserService);
